Index: code/branches/FICN/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/CMakeLists.txt	(revision 340)
+++ code/branches/FICN/src/orxonox/CMakeLists.txt	(revision 341)
@@ -1,14 +1,27 @@
 PROJECT(Orxonox)
 
-SET(SRC_FILES orxonox.cc spaceship_steering.cc)
+SET( ORXONOX_SRC_FILES
+	orxonox.cc
+	spaceship_steering.cc
+)
 
-ADD_EXECUTABLE(../../bin/main ${SRC_FILES})
+ADD_EXECUTABLE(../../bin/main ${ORXONOX_SRC_FILES})
 
-TARGET_LINK_LIBRARIES(../../bin/main ${OGRE_LIBRARIES} ${OIS_LIBRARIES} loader )
-
-INCLUDE_DIRECTORIES(..)
 
 ADD_SUBDIRECTORY(core)
+ADD_SUBDIRECTORY(hud)
 ADD_SUBDIRECTORY(objects)
-ADD_SUBDIRECTORY(hud)
 ADD_SUBDIRECTORY(weapon)
+
+
+TARGET_LINK_LIBRARIES( ../../bin/main
+	${OGRE_LIBRARIES}
+	${OIS_LIBRARIES}
+	${ENet_LIBRARY}
+	loader
+	network
+	core
+	hud
+	objects
+	weapon
+)
Index: code/branches/FICN/src/orxonox/Flocking.h
===================================================================
--- code/branches/FICN/src/orxonox/Flocking.h	(revision 340)
+++ 	(revision )
@@ -1,143 +1,0 @@
-//
-//
-//      TODO: testing orxonox -flocking interface
-//            testing algorithm
-
-// ueberpruefen ob vektoren relativ richtig berechnet werden
-//
-//My Flocking Class
-
-#ifndef Flocking_Class
-#define Flocking_Class
-
-#include <Ogre.h>
-#include <OgreVector3.h>
-
-#include <iostream>
-
-
-#endif
-
-using namespace std;
-using namespace Ogre;
-
-class Element // An element that flocks
-{
-
-  public:
-    Vector3 location;  // locationvector of the element
-    Vector3 speed;  // speedvector of the element
-    Vector3 acceleration;  // accelerationvector of the element
-
-  Element() {
-    acceleration = (0,0,0);
-    speed = (0,0,0);
-    location = (0,0,0);
-  }
-
-  Element(Vector3 location_, Vector3 speed_, Vector3 acceleration_) {
-    acceleration = acceleration_;
-    speed = speed_;
-    location = location_;
-  }
-
-  void setValues(Vector3 location_, Vector3 speed_, Vector3 acceleration_) {
-    acceleration = acceleration_;
-    speed = speed_;
-    location = location_;
-  }
-
-  //calculates the distance between the element and an other point given by temp
-  float getDistance(Element temp) {
-    Vector3 distance = temp.location-location;  //this doesn't work
-    return distance.length();
-  }
-
-//EINF[GEN DES ELEMENTS
-  void update(Element arrayOfElements[], const FrameEvent& time) {
-    calculateAcceleration(arrayOfElements);  //updates the acceleration
-    calculateSpeed(time);  //updates the speed
-    calculateLocation(time);  //updates the location
-  }
-
-//EINF[GEN DES ELEMENTS
-  void calculateAcceleration(Element arrayOfElements[]) {
-  //calculates the accelerationvector based on the steeringvectors of
-  //separtion, alignment and cohesion.
-  acceleration = separation(arrayOfElements) + alignment(arrayOfElements) + cohesion(arrayOfElements);
-  }
-
-  void calculateSpeed(const FrameEvent& time) {
-    speed = speed + acceleration*time.timeSinceLastFrame;
-  }
-
-  void calculateLocation(const FrameEvent& time) {
-    location = location + speed*time.timeSinceLastFrame;
-  }
-
-
-  Vector3 separation(Element arrayOfElements[]) {
-    Vector3* steering = new Vector3(0,0,0); //steeringvector
-    int numberOfNeighbour = 0;  //number of observed neighbours
-    //go through all elements
-    for(int i=0; i<3; i++) {  //just working with 3 elements at the moment
-      Element actual = arrayOfElements[i];  //get the actual element
-      float distance = getDistance(actual);  //get distance between this and actual
-//DUMMY SEPERATION DETECTION DISTANCE =100
-      if ((distance > 0) && (distance<100)) {  //do only if actual is inside detectionradius
-        Vector3 inverseDistance = actual.location-location;  //calculate the distancevector heading towards this
-        inverseDistance = inverseDistance.normalise(); //does this work correctly?  //normalise the distancevector
-        inverseDistance = inverseDistance/*/distance*/;  //devide distancevector by distance (the closer the bigger gets the distancevector -> steeringvector)
-        *steering = *steering + inverseDistance;  //add up all significant steeringvectors
-        numberOfNeighbour++;  //counts the elements inside the detectionradius
-      }
-    }
-    if(numberOfNeighbour > 0) {
-    *steering = *steering / (float)numberOfNeighbour;  //devide the sum of steeringvectors by the number of elements -> separation steeringvector
-    }
-    return *steering;
-  }
-
-  Vector3 alignment(Element arrayOfElements[]) {
-    Vector3* steering = new Vector3(0,0,0); //steeringvector
-    int numberOfNeighbour = 0;  //number of observed neighbours
-    //go through all elements
-    for(int i=0; i<3; i++) {  //just working with 3 elements at the moment
-      Element actual = arrayOfElements[i];  //get the actual element
-      float distance = getDistance(actual);  //get distance between this and actual
-//DUMMY ALIGNMENT DETECTION DISTANCE = 1000
-      if ((distance > 0) && (distance<1000)) {  //check if actual element is inside detectionradius
-        *steering = *steering + actual.speed;  //add up all speedvectors inside the detectionradius
-        numberOfNeighbour++;  //counts the elements inside the detectionradius
-      }
-    }
-    if(numberOfNeighbour > 0) {
-    *steering = *steering / (float)numberOfNeighbour;  //devide the sum of steeringvectors by the number of elements -> alignment steeringvector
-    }
-    return *steering;
-  }
-
-  Vector3 cohesion(Element arrayOfElements[]) {
-    Vector3* steering = new Vector3(0,0,0); //steeringvector
-    int numberOfNeighbour = 0;  //number of observed neighbours
-    //go through all elements
-    for(int i=0; i<3; i++) {  //just working with 3 elements at the moment
-      Element actual = arrayOfElements[i];  //get the actual element
-      float distance = getDistance(actual);  //get distance between this and actual
-// DUMMY COHESION DETECTION DISTANCE = 1000
-      if ((distance > 0) && (distance<1000)) {  //check if actual element is inside detectionradius
-        *steering = *steering + actual.location;  //add up all locations of elements inside the detectionradius
-        numberOfNeighbour++;  //counts the elements inside the detectionradius
-      }
-     }
-    if(numberOfNeighbour > 0) {
-    *steering = *steering  / (float)numberOfNeighbour;  //devide the sum steeringvector by the number of elements -> cohesion steeringvector
-    }
-    return *steering;
-  }
- 
-};
-
-
-
-//End of My Flocking Class
Index: code/branches/FICN/src/orxonox/core/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/core/CMakeLists.txt	(revision 340)
+++ code/branches/FICN/src/orxonox/core/CMakeLists.txt	(revision 341)
@@ -1,5 +1,11 @@
 PROJECT(Orxonox)
 
-SET(SRC_FILES IdentifierList.cc Identifier.cc MetaObjectList.cc Factory.cc OrxonoxClass.cc)
+SET( CORE_SRC_FILES
+	Factory.cc
+	IdentifierList.cc
+	Identifier.cc
+	MetaObjectList.cc
+	OrxonoxClass.cc
+)
 
-ADD_LIBRARY(core ${SRC_FILES})
+ADD_LIBRARY(core ${CORE_SRC_FILES})
Index: code/branches/FICN/src/orxonox/hud/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/hud/CMakeLists.txt	(revision 340)
+++ code/branches/FICN/src/orxonox/hud/CMakeLists.txt	(revision 341)
@@ -1,5 +1,10 @@
 PROJECT(Orxonox)
 
-SET(SRC_FILES hud_overlay.cc test_overlay.cc)
+SET( HUD_SRC_FILES
+	hud_overlay.cc
+	test_overlay.cc
+)
 
-ADD_LIBRARY(objects ${SRC_FILES})
+LINK_DIRECTORIES(.)
+
+ADD_LIBRARY(hud ${HUD_SRC_FILES})
Index: code/branches/FICN/src/orxonox/hud/hud_overlay.h
===================================================================
--- code/branches/FICN/src/orxonox/hud/hud_overlay.h	(revision 340)
+++ code/branches/FICN/src/orxonox/hud/hud_overlay.h	(revision 341)
@@ -33,5 +33,5 @@
 #include "OgrePrerequisites.h"
 
-#include "../orxonox_prerequisites.h"
+#include "orxonox/orxonox_prerequisites.h"
 
 
Index: code/branches/FICN/src/orxonox/hud/test_overlay.h
===================================================================
--- code/branches/FICN/src/orxonox/hud/test_overlay.h	(revision 340)
+++ code/branches/FICN/src/orxonox/hud/test_overlay.h	(revision 341)
@@ -33,5 +33,5 @@
 #include "OgrePrerequisites.h"
 
-#include "../orxonox_prerequisites.h"
+#include "orxonox/orxonox_prerequisites.h"
 
 
Index: code/branches/FICN/src/orxonox/inertial_node.h
===================================================================
--- code/branches/FICN/src/orxonox/inertial_node.h	(revision 340)
+++ 	(revision )
@@ -1,77 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software: you can redistribute it and/or modify
- *   it under the terms of the GNU General Public License as published by
- *   the Free Software Foundation, either version 3 of the License, or
- *   (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-
-#ifndef INERTIAL_NODE_H
-#define INERTIAL_NODE_H
-
-#include "OgrePrerequisites.h"
-
-#include "orxonox_prerequisites.h"
-
-
-namespace orxonox {
-
-  class InertialNode
-  {
-  public:
-    InertialNode(Ogre::SceneNode*, Ogre::Vector3);
-	  ~InertialNode();
-
-    InertialNode* createChildNode();
-
-    InertialNode* getParentNode();
-
-    Ogre::SceneNode* getSceneNode();
-
-    Ogre::Vector3 getSpeed();
-
-    Ogre::Vector3 getWorldSpeed();
-
-    void addSpeed(Ogre::Vector3);
-
-  protected:
-    InertialNode(InertialNode*, Ogre::Vector3 speed = Ogre::Vector3::ZERO);
-    void addChild(InertialNode*);
-
-  public:
-
-  protected:
-    InertialNode **childList_;
-    int childListSize_;
-    int childListIndex_;
-
-    Ogre::SceneNode *node_;
-	  Ogre::Vector3 speed_;
-
-    InertialNode* parentNode_;
-
-  };
-
-}
-
-#endif /* INERTIAL_NODE_H */
Index: code/branches/FICN/src/orxonox/objects/BaseObject.h
===================================================================
--- code/branches/FICN/src/orxonox/objects/BaseObject.h	(revision 340)
+++ code/branches/FICN/src/orxonox/objects/BaseObject.h	(revision 341)
@@ -2,5 +2,5 @@
 #define _BaseObject_H__
 
-#include "../core/IdentifierIncludes.h"
+#include "orxonox/core/IdentifierIncludes.h"
 
 namespace orxonox
Index: code/branches/FICN/src/orxonox/objects/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/objects/CMakeLists.txt	(revision 340)
+++ code/branches/FICN/src/orxonox/objects/CMakeLists.txt	(revision 341)
@@ -1,5 +1,10 @@
 PROJECT(Orxonox)
 
-SET(SRC_FILES BaseObject.cc test1.cc test2.cc test3.cc)
+SET( OBJECTS_SRC_FILES
+	BaseObject.cc
+	test1.cc
+	test2.cc
+	test3.cc
+)
 
-ADD_LIBRARY(objects ${SRC_FILES})
+ADD_LIBRARY(objects ${OBJECTS_SRC_FILES})
Index: code/branches/FICN/src/orxonox/ogre_control.h
===================================================================
--- code/branches/FICN/src/orxonox/ogre_control.h	(revision 340)
+++ 	(revision )
@@ -1,71 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software: you can redistribute it and/or modify
- *   it under the terms of the GNU General Public License as published by
- *   the Free Software Foundation, either version 3 of the License, or
- *   (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-
-#ifndef OGRE_CONTROL_H
-#define OGRE_CONTROL_H
-
-#include "OgrePrerequisites.h"
-
-#include "orxonox_prerequisites.h"
-
-
-namespace orxonox {
-
-  class OgreControl
-  {
-  public:
-	  OgreControl();
-
-	  virtual ~OgreControl();
-
-	  /** Sets up the application - returns false if the user chooses to abandon configuration. */
-	  virtual bool initialise();
-
-    virtual Ogre::Root* getRoot();
-
-	  virtual Ogre::RenderWindow* getRenderWindow();
-
-	  virtual Ogre::String getResourcePath();
-
-  protected:
-	  /** Configures the application - returns false if the user chooses to abandon configuration. */
-	  virtual bool configure(void);
-
-	  /// Method which will define the source of resources (other than current folder)
-	  virtual void setupResources(void);
-
-  protected:
-	  Ogre::Root         *root_;
-	  Ogre::RenderWindow *window_;
-	  Ogre::String  resourcePath_;
-
-  };
-
-}
-
-#endif /* OGRE_CONTROL_H */
Index: code/branches/FICN/src/orxonox/orxonox.cc
===================================================================
--- code/branches/FICN/src/orxonox/orxonox.cc	(revision 340)
+++ code/branches/FICN/src/orxonox/orxonox.cc	(revision 341)
@@ -42,11 +42,6 @@
 #include "loader/LevelLoader.h"
 
-#include "orxonox.h"
-
-#include "Flocking.h"
-
 #include "spaceship_steering.h"
 SpaceshipSteering* steering;
-
 
 
Index: code/branches/FICN/src/orxonox/orxonox.h
===================================================================
--- code/branches/FICN/src/orxonox/orxonox.h	(revision 340)
+++ 	(revision )
@@ -1,59 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software: you can redistribute it and/or modify
- *   it under the terms of the GNU General Public License as published by
- *   the Free Software Foundation, either version 3 of the License, or
- *   (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-
-#ifndef ORXONOX_H
-#define ORXONOX_H
-
-#include "OgrePrerequisites.h"
-
-#include "orxonox_prerequisites.h"
-
-namespace orxonox {
-
-  class Orxonox
-  {
-  public:
-    Orxonox();
-    virtual ~Orxonox();
-	  virtual void go();
-
-  protected:
-	  virtual bool setup(void);
-
-	  virtual void destroy(void);
-
-  protected:
-	  OgreControl *ogre_;
-	  RunManager  *runMgr_;
-	  Ogre::Timer *timer_;
-
-  };
-
-}
-
-#endif /* ORXONOX_H */
Index: code/branches/FICN/src/orxonox/orxonox_prerequisites.h
===================================================================
--- code/branches/FICN/src/orxonox/orxonox_prerequisites.h	(revision 340)
+++ 	(revision )
@@ -1,64 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software: you can redistribute it and/or modify
- *   it under the terms of the GNU General Public License as published by
- *   the Free Software Foundation, either version 3 of the License, or
- *   (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-
-#ifndef ORXONOX_PREREQUISITES_H
-#define ORXONOX_PREREQUISITES_H
-
-namespace orxonox {
-
-  class CameraManager;
-  class InertialNode;
-  class OgreControl;
-  class Orxonox;
-  class OrxonoxShip;
-  class OrxonoxScene;
-  class RunManager;
-
-
-  namespace weapon {
-
-    class AmmunitionDump;
-    class Bullet;
-    class BulletManager;
-    class BaseWeapon;
-    class BarrelGun;
-    class WeaponStation;
-
-  }
-
-
-  namespace hud {
-    
-    class HUDOverlay;
-    class TestOverlay;
-
-  }
-
-}
-
-#endif /* ORXONOX_PREREQUISITES_H */
Index: code/branches/FICN/src/orxonox/orxonox_scene.h
===================================================================
--- code/branches/FICN/src/orxonox/orxonox_scene.h	(revision 340)
+++ 	(revision )
@@ -1,70 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software: you can redistribute it and/or modify
- *   it under the terms of the GNU General Public License as published by
- *   the Free Software Foundation, either version 3 of the License, or
- *   (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-
-#ifndef ORXONOX_SCENE_H
-#define ORXONOX_SCENE_H
-
-#include "OgrePrerequisites.h"
-
-#include "orxonox_prerequisites.h"
-
-
-namespace orxonox {
-
-  class OrxonoxScene
-  {
-  public:
-    OrxonoxScene(Ogre::SceneManager*);
-
-	  virtual ~OrxonoxScene();
-
-	  virtual bool initialise();
-
-	  virtual bool tick(unsigned long, Ogre::Real);
-
-  protected:
-	  /// method where you can perform resource group loading
-	  virtual void loadResources();
-
-	  /// Define what is in the scene
-	  virtual void createScene();
-
-  protected:
-	  Ogre::SceneManager* sceneMgr_;
-
-	  //specific variables for test purposes
-	  Ogre::Light        *light_;
-	  Ogre::SceneNode    *lightNode_;
-	  Ogre::BillboardSet *bbs_;
-	  Ogre::Real distance_;
-    Ogre::Real radius_;
-  };
-
-}
-
-#endif /* ORXONOX_SCENE_H */
Index: code/branches/FICN/src/orxonox/orxonox_ship.h
===================================================================
--- code/branches/FICN/src/orxonox/orxonox_ship.h	(revision 340)
+++ 	(revision )
@@ -1,86 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software: you can redistribute it and/or modify
- *   it under the terms of the GNU General Public License as published by
- *   the Free Software Foundation, either version 3 of the License, or
- *   (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-
-#ifndef ORXONOX_SHIP_H
-#define ORXONOX_SHIP_H
-
-#include "OgrePrerequisites.h"
-
-#include "orxonox_prerequisites.h"
-
-
-namespace orxonox {
-
-  class OrxonoxShip
-  {
-  public:
-    OrxonoxShip(Ogre::SceneNode*);
-	  virtual ~OrxonoxShip();
-
-	  virtual bool initialise();
-
-	  void setMainThrust(const Ogre::Real);
-	  void setSideThrust(const Ogre::Real);
-    void setYThrust(const Ogre::Real);
-	  void turnUpAndDown(const Ogre::Radian&);
-	  void turnLeftAndRight(const Ogre::Radian&);
-
-    InertialNode* getRootNode();
-    Ogre::Vector3 getSpeed();
-
-    weapon::BaseWeapon* getMainWeapon();
-
-    int getAmmoStock();
-
-	  bool tick(unsigned long, Ogre::Real);
-
-  protected:
-
-  protected:
-	  Ogre::SceneManager *sceneMgr_;
-	  //Ogre::SceneNode *rootNode_;
-    InertialNode *rootNode_;
-	  Ogre::Entity *shipEntity_;
-
-	  //Ogre::Vector3 currentSpeed_;  // relative to space
-	  Ogre::Vector3 currentThrust_; // relative to the ship
-    Ogre::Real baseThrust_;
-	  int objectCounter_;
-
-    weapon::BulletManager *bulletManager_;
-	  //Ogre::Vector3 bulletSpeed_;
-
-    weapon::BaseWeapon *mainWeapon_;
-    weapon::WeaponStation *railGunStation_;
-
-    weapon::AmmunitionDump *ammoDump_;
-  };
-
-}
-
-#endif /* ORXONOX_SHIP_H */
Index: code/branches/FICN/src/orxonox/run_manager.h
===================================================================
--- code/branches/FICN/src/orxonox/run_manager.h	(revision 340)
+++ 	(revision )
@@ -1,142 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software: you can redistribute it and/or modify
- *   it under the terms of the GNU General Public License as published by
- *   the Free Software Foundation, either version 3 of the License, or
- *   (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-
-#ifndef RUN_MANAGER_H
-#define RUN_MANAGER_H
-
-#include "OgrePrerequisites.h"
-#include "OgreWindowEventUtilities.h"
-//#include "OgreTextureManager.h"
-
-#include <OIS/OISPrereqs.h>
-
-#include "orxonox_prerequisites.h"
-
-
-namespace orxonox {
-
-  // let the class inherit from WindowEventListener in order for the RunMgr
-  // to act as the central point of all the calcuations in Orxonox
-  class RunManager : public Ogre::WindowEventListener
-  {
-  public:
-    virtual ~RunManager();
-    
-    void initialise(OgreControl*);
-
-    bool tick(unsigned long, Ogre::Real);
-
-    Ogre::SceneManager& getSceneManager();
-
-    Ogre::SceneManager* getSceneManagerPtr();
-
-    weapon::BulletManager* getBulletManagerPtr();
-
-    int getAmmunitionID(const Ogre::String&);
-
-    int getNumberOfAmmos();
-
-    static RunManager* createSingleton();
-
-    static void destroySingleton();
-
-    static RunManager& getSingleton(void);
-
-    static RunManager* getSingletonPtr(void);
-
-
-  protected:
-    RunManager();
-
-	  void createCamera(void);
-
-	  void createViewports(void);
-
-
-	  /** EVENT HANDLING **/
-
-	  //Adjust mouse clipping area
-	  void windowResized(Ogre::RenderWindow*);
-
-	  //Unattach OIS before window shutdown (very important under Linux)
-	  void windowClosed(Ogre::RenderWindow*);
-
-
-	  /** INPUT PROCESSING **/
-	  bool processUnbufferedKeyInput();
-
-	  bool processUnbufferedMouseInput();
-
-
-	  /** OUTPUT **/
-
-	  void showDebugOverlay(bool);
-
-  protected:
-    // directly Ogre related fields
-	  Ogre::SceneManager *sceneMgr_;
-	  Ogre::RenderWindow *window_;
-	  Ogre::Camera       *camera_;
-
-
-    // self made orxonox fields
-	  OgreControl  *ogre_;
-	  OrxonoxScene *backgroundScene_;
-	  OrxonoxShip  *playerShip_;
-    hud::TestOverlay *hud_;
-
-    // Bullet manager
-    weapon::BulletManager *bulletManager_;
-
-    const Ogre::Real mouseSensitivity_;
-
-	  // previously elapsed render time
-	  unsigned long totalTime_;
-
-
-    // fields from the example framework
-	  bool statsOn_;
-
-	  unsigned int screenShotCounter_;
-	  // just to stop toggles flipping too fast
-	  Ogre::Real timeUntilNextToggle_;
-
-	  //OIS Input devices
-	  OIS::InputManager* inputManager_;
-	  OIS::Mouse*    mouse_;
-	  OIS::Keyboard* keyboard_;
-	  OIS::JoyStick* joystick_;
-
-    // singleton pointer
-    static RunManager *singletonPtr_s;
-
-  };
-
-}
-
-#endif /* RUN_MANAGER_H */
Index: code/branches/FICN/src/orxonox/weapon/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/weapon/CMakeLists.txt	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/CMakeLists.txt	(revision 341)
@@ -1,6 +1,5 @@
 PROJECT(Orxonox)
 
-# create a few variables to simplify life
-SET( WEAPON_SRC
+SET( WEAPON_SRC_FILES
 	ammunition_dump.cc
 	barrel_gun.cc
@@ -11,5 +10,3 @@
 )
 
-INCLUDE_DIRECTORIES(..)
-
-ADD_LIBRARY(weapon ${WEAPON_SRC})
+ADD_LIBRARY(weapon ${WEAPON_SRC_FILES})
Index: code/branches/FICN/src/orxonox/weapon/ammunition_dump.cc
===================================================================
--- code/branches/FICN/src/orxonox/weapon/ammunition_dump.cc	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/ammunition_dump.cc	(revision 341)
@@ -26,5 +26,5 @@
  */
 
-#include "run_manager.h"
+#include "orxonox/run_manager.h"
 
 #include "ammunition_dump.h"
Index: code/branches/FICN/src/orxonox/weapon/ammunition_dump.h
===================================================================
--- code/branches/FICN/src/orxonox/weapon/ammunition_dump.h	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/ammunition_dump.h	(revision 341)
@@ -32,5 +32,5 @@
 #include "OgrePrerequisites.h"
 
-#include "orxonox_prerequisites.h"
+#include "orxonox/orxonox_prerequisites.h"
 
 
Index: code/branches/FICN/src/orxonox/weapon/barrel_gun.cc
===================================================================
--- code/branches/FICN/src/orxonox/weapon/barrel_gun.cc	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/barrel_gun.cc	(revision 341)
@@ -33,7 +33,8 @@
 #include "OgreSceneManager.h"
 
+#include "orxonox/inertial_node.h"
+
 #include "bullet.h"
 #include "bullet_manager.h"
-#include "inertial_node.h"
 #include "ammunition_dump.h"
 #include "base_weapon.h"
Index: code/branches/FICN/src/orxonox/weapon/barrel_gun.h
===================================================================
--- code/branches/FICN/src/orxonox/weapon/barrel_gun.h	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/barrel_gun.h	(revision 341)
@@ -32,5 +32,5 @@
 #include "OgrePrerequisites.h"
 
-#include "orxonox_prerequisites.h"
+#include "orxonox/orxonox_prerequisites.h"
 
 
Index: code/branches/FICN/src/orxonox/weapon/base_weapon.cc
===================================================================
--- code/branches/FICN/src/orxonox/weapon/base_weapon.cc	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/base_weapon.cc	(revision 341)
@@ -33,9 +33,10 @@
 #include "OgreSceneManager.h"
 
+#include "orxonox/inertial_node.h"
+#include "orxonox/run_manager.h"
+
 #include "bullet.h"
 #include "bullet_manager.h"
-#include "inertial_node.h"
 #include "ammunition_dump.h"
-#include "run_manager.h"
 
 #include "base_weapon.h"
Index: code/branches/FICN/src/orxonox/weapon/base_weapon.h
===================================================================
--- code/branches/FICN/src/orxonox/weapon/base_weapon.h	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/base_weapon.h	(revision 341)
@@ -32,5 +32,5 @@
 #include "OgrePrerequisites.h"
 
-#include "orxonox_prerequisites.h"
+#include "orxonox/orxonox_prerequisites.h"
 
 
Index: code/branches/FICN/src/orxonox/weapon/bullet.h
===================================================================
--- code/branches/FICN/src/orxonox/weapon/bullet.h	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/bullet.h	(revision 341)
@@ -32,5 +32,5 @@
 #include "OgrePrerequisites.h"
 
-#include "orxonox_prerequisites.h"
+#include "orxonox/orxonox_prerequisites.h"
 
 
Index: code/branches/FICN/src/orxonox/weapon/bullet_manager.h
===================================================================
--- code/branches/FICN/src/orxonox/weapon/bullet_manager.h	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/bullet_manager.h	(revision 341)
@@ -32,5 +32,5 @@
 #include "OgrePrerequisites.h"
 
-#include "orxonox_prerequisites.h"
+#include "orxonox/orxonox_prerequisites.h"
 
 
Index: code/branches/FICN/src/orxonox/weapon/weapon_station.h
===================================================================
--- code/branches/FICN/src/orxonox/weapon/weapon_station.h	(revision 340)
+++ code/branches/FICN/src/orxonox/weapon/weapon_station.h	(revision 341)
@@ -32,5 +32,5 @@
 #include "OgrePrerequisites.h"
 
-#include "orxonox_prerequisites.h"
+#include "orxonox/orxonox_prerequisites.h"
 
 