Index: /code/branches/audio/src/audio/AudioBuffer.cc
===================================================================
--- /code/branches/audio/src/audio/AudioBuffer.cc	(revision 349)
+++ /code/branches/audio/src/audio/AudioBuffer.cc	(revision 349)
@@ -0,0 +1,14 @@
+#include "AudioBuffer.h"
+
+namespace audio
+{
+	AudioBuffer::AudioBuffer(std::string fileName)
+	{
+		
+	}
+	
+	AudioBuffer::~AudioBuffer()
+	{
+		
+	}
+}
Index: /code/branches/audio/src/audio/AudioBuffer.h
===================================================================
--- /code/branches/audio/src/audio/AudioBuffer.h	(revision 349)
+++ /code/branches/audio/src/audio/AudioBuffer.h	(revision 349)
@@ -0,0 +1,27 @@
+#ifndef AUDIOBUFFER_H_
+#define AUDIOBUFFER_H_
+
+#include <iostream>
+#include <string>
+#include <vector>
+
+#include "../../include/AL/al.h"
+#include "../../include/AL/alc.h"
+#include "../../include/AL/alut.h"
+
+namespace audio
+{
+	class AudioBuffer
+	{
+	public:
+		AudioBuffer(std::string fileName);
+		~AudioBuffer();
+	private:
+		// Buffers hold sound data.
+		ALuint data;
+		// Identifier
+		std::string name;
+	};
+}
+
+#endif /*AUDIOBUFFER_H_*/
Index: /code/branches/audio/src/audio/AudioManager.cc
===================================================================
--- /code/branches/audio/src/audio/AudioManager.cc	(revision 349)
+++ /code/branches/audio/src/audio/AudioManager.cc	(revision 349)
@@ -0,0 +1,29 @@
+#include "AudioManager.h"
+
+namespace audio
+{
+	AudioManager::AudioManager()
+	{
+		
+	}
+		
+	AudioManager::~AudioManager()
+	{
+		
+	}
+	
+	void AudioManager::setPos(std::vector<float> newPosition)
+	{
+		
+	}
+
+	void AudioManager::setSpeed(std::vector<float> newSpeed)
+	{
+		
+	}
+
+	void AudioManager::setOri(std::vector<float> at, std::vector<float> up)
+	{
+		
+	}
+}
Index: /code/branches/audio/src/audio/AudioManager.h
===================================================================
--- /code/branches/audio/src/audio/AudioManager.h	(revision 349)
+++ /code/branches/audio/src/audio/AudioManager.h	(revision 349)
@@ -0,0 +1,47 @@
+#ifndef AUDIOMANAGER_H_
+#define AUDIOMANAGER_H_
+
+#include <iostream>
+#include <string>
+#include <vector>
+
+#include "../../include/AL/al.h"
+#include "../../include/AL/alc.h"
+#include "../../include/AL/alut.h"
+
+#include "AudioBuffer.h"
+#include "AudioSource.h"
+
+namespace audio
+{
+	class AudioManager
+	{
+	public:
+		// Init audio 
+		AudioManager();
+		// Kill audio and set buffers, sources and memory free
+		~AudioManager();
+		// Set listener position
+		void setPos(std::vector<float> newPosition);
+		// Set listener speed
+		void setSpeed(std::vector<float> newSpeed);
+		// Set listener orientation (first is direction
+		// the listener looks at, the second is the direction
+		// upwards the listener)
+		void setOri(std::vector<float> at, std::vector<float> up);
+	private:
+		// Vector containing all audio files
+		std::vector<AudioBuffer> buffers;
+		// Vector containing all audio sources which referer to one buffer
+		std::vector<AudioSource> sources;
+		// The ambient background sound 	
+		AudioSource ambient;
+		
+		std::vector<float> listenerPosition;
+		std::vector<float> listenerSpeed;
+		std::vector<float> listenerAt;
+		std::vector<float> listenerup;		
+	};	
+}
+
+#endif /*AUDIOMANAGER_H_*/
Index: /code/branches/audio/src/audio/AudioSource.cc
===================================================================
--- /code/branches/audio/src/audio/AudioSource.cc	(revision 349)
+++ /code/branches/audio/src/audio/AudioSource.cc	(revision 349)
@@ -0,0 +1,14 @@
+#include "AudioSource.h"
+
+namespace audio
+{
+	AudioSource::AudioSource()
+	{
+
+	}
+	
+	AudioSource::~AudioSource()
+	{
+		
+	}
+}
Index: /code/branches/audio/src/audio/AudioSource.h
===================================================================
--- /code/branches/audio/src/audio/AudioSource.h	(revision 349)
+++ /code/branches/audio/src/audio/AudioSource.h	(revision 349)
@@ -0,0 +1,24 @@
+#ifndef AUDIOSOURCE_H_
+#define AUDIOSOURCE_H_
+
+#include <iostream>
+#include <string>
+#include <vector>
+
+#include "../../include/AL/al.h"
+#include "../../include/AL/alc.h"
+#include "../../include/AL/alut.h"
+
+namespace audio
+{
+	class AudioSource
+	{
+	public:
+		AudioSource();
+		~AudioSource();
+	private:
+
+	};
+}
+
+#endif /*AUDIOSOURCE_H_*/
Index: /code/branches/audio/src/audio/CMakeLists.txt
===================================================================
--- /code/branches/audio/src/audio/CMakeLists.txt	(revision 348)
+++ /code/branches/audio/src/audio/CMakeLists.txt	(revision 349)
@@ -2,10 +2,12 @@
 
 SET(SRC_FILES 
-	Ambient.cc
-	AudioObject.cc
+	AudioManager.cc
+	AudioBuffer.cc
+	AudioSource.cc
 )
 SET(INC_FILES 
-	Ambient.h
-	AudioObject.h
+	AudioManager.h
+	AudioBuffer.h
+	AudioSource.h
 )
 
Index: /code/branches/audio/src/orxonox/orxonox.cc
===================================================================
--- /code/branches/audio/src/orxonox/orxonox.cc	(revision 348)
+++ /code/branches/audio/src/orxonox/orxonox.cc	(revision 349)
@@ -41,5 +41,5 @@
 #include "xml/xmlParser.h"
 #include "loader/LevelLoader.h"
-#include "audio/Ambient.h"
+#include "audio/AudioManager.h"
 
 
@@ -191,6 +191,6 @@
       void createScene(void)
       {
-		audio::Ambient* bgsound = new audio::Ambient("wavdata/pirate.wav");
-		bgsound->play();
+		audio::AudioManager* auMan = new audio::AudioManager();
+				
 				        
         string levelFile = "sp_level_moonstation.oxw";