Index: code/branches/FICN/CMakeLists.txt
===================================================================
--- code/branches/FICN/CMakeLists.txt	(revision 375)
+++ code/branches/FICN/CMakeLists.txt	(revision 376)
@@ -1,9 +1,9 @@
 PROJECT(Orxonox)
-#set some global variables, which are use throughout the project
+#set some global variables, which are used throughout the project
 
 #Create some verbose output
 SET(CMAKE_VERBOSE_MAKEFILE TRUE)
 
-# set eNet search path
+# set boost search path
 SET(Boost_INCLUDE_DIR "/usr/include/boost/")
 
@@ -47,6 +47,4 @@
 #This sets where to look for "Find*.cmake" files
 SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
-# SET(BOOST_LIBDIR /usr/pack/boost-1.33.1-mo/i686-debian-linux3.1/lib/)
-# SET(BOOST_INCDIR /usr/pack/boost-1.33.1-mo/i686-debian-linux3.1/include/)
 
 #Performs the search and sets the variables
@@ -58,22 +56,22 @@
 FIND_PACKAGE(Boost)
 
-#Sets the search paths for the linking
+#Sets the search paths for the linker
 LINK_DIRECTORIES(
-	${OGRE_LIB_DIR}
-	${OIS_LIB_DIR}
-	${CEGUI_LIB_DIR}
-	${CEGUI_OGRE_LIB_DIR}
-	${ENet_LIBRARY}
-	${Boost_LIBRARY_DIRS}
+  ${OGRE_LIB_DIR}
+  ${OIS_LIB_DIR}
+  ${CEGUI_LIB_DIR}
+  ${CEGUI_OGRE_LIB_DIR}
+  ${ENet_LIBRARY}
+  ${Boost_LIBRARY_DIRS}
 )
 
 #Sets the search path for include files
 INCLUDE_DIRECTORIES(
-	${OGRE_INCLUDE_DIR}
-	${OIS_INCLUDE_DIR}
-	${CEGUI_INCLUDE_DIR}
-	${CEGUI_OGRE_INCLUDE_DIR}
-	${ENet_INCLUDE_DIR}
-	${Boost_INCLUDE_DIRS}
+  ${OGRE_INCLUDE_DIR}
+  ${OIS_INCLUDE_DIR}
+  ${CEGUI_INCLUDE_DIR}
+  ${CEGUI_OGRE_INCLUDE_DIR}
+  ${ENet_INCLUDE_DIR}
+  ${Boost_INCLUDE_DIRS}
 )
 
Index: code/branches/FICN/src/loader/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/loader/CMakeLists.txt	(revision 375)
+++ code/branches/FICN/src/loader/CMakeLists.txt	(revision 376)
@@ -3,6 +3,6 @@
 # TODO find a cleaner way to include xmlParser
 SET( LOADER_SRC_FILES
-	LevelLoader.cc
-	../xml/xmlParser.cc
+  LevelLoader.cc
+  ../xml/xmlParser.cc
 )
 
Index: code/branches/FICN/src/network/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/network/CMakeLists.txt	(revision 375)
+++ code/branches/FICN/src/network/CMakeLists.txt	(revision 376)
@@ -2,16 +2,15 @@
 
 SET( NETWORK_SRC_FILES
-	Client.cc
-	ClientConnection.cc
-	ConnectionManager.cc
-	GameStateManager.cc
-	PacketBuffer.cc
-	PacketDecoder.cc
-	PacketGenerator.cc
-	Server.cc
-	Synchronisable.cc
+  Client.cc
+  ClientConnection.cc
+  ConnectionManager.cc
+  GameStateManager.cc
+  PacketBuffer.cc
+  PacketDecoder.cc
+  PacketGenerator.cc
+  Server.cc
+  Synchronisable.cc
 )
 
 ADD_LIBRARY(network SHARED ${NETWORK_SRC_FILES})
-TARGET_LINK_LIBRARIES(network ${ENet_LIBRARY} ${Boost_LIBRARIES})
-SET_TARGET_PROPERTIES(network PROPERTIES LINK_FLAGS "--no-undefined")
+TARGET_LINK_LIBRARIES(network ${ENet_LIBRARY} ${Boost_thread_LIBRARIES})
Index: code/branches/FICN/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/CMakeLists.txt	(revision 375)
+++ code/branches/FICN/src/orxonox/CMakeLists.txt	(revision 376)
@@ -1,10 +1,16 @@
 PROJECT(Orxonox)
 
+ADD_SUBDIRECTORY(core)
+ADD_SUBDIRECTORY(hud)
+ADD_SUBDIRECTORY(objects)
+ADD_SUBDIRECTORY(weapon)
+
+
 SET( ORXONOX_SRC_FILES
-	orxonox.cc
-	orxonox_scene.cc
-	orxonox_ship.cc
-	run_manager.cc
-	spaceship_steering.cc
+  orxonox.cc
+  orxonox_scene.cc
+  orxonox_ship.cc
+  run_manager.cc
+  spaceship_steering.cc
   inertial_node.cc
 )
@@ -14,20 +20,12 @@
 SET_TARGET_PROPERTIES(../../bin/main PROPERTIES LINK_FLAGS "--no-undefined" )
 
-
-ADD_SUBDIRECTORY(core)
-ADD_SUBDIRECTORY(hud)
-ADD_SUBDIRECTORY(objects)
-ADD_SUBDIRECTORY(weapon)
-
-
 TARGET_LINK_LIBRARIES( ../../bin/main 
-	${OGRE_LIBRARIES}
-	${OIS_LIBRARIES}
-	${ENet_LIBRARY}
-	loader
-	network
-	core
-	hud
-	objects
-	weapon
+  ${OGRE_LIBRARIES}
+  ${OIS_LIBRARIES}
+  loader
+  network
+  core
+  hud
+  objects
+  weapon
 )
Index: code/branches/FICN/src/orxonox/core/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/core/CMakeLists.txt	(revision 375)
+++ code/branches/FICN/src/orxonox/core/CMakeLists.txt	(revision 376)
@@ -2,11 +2,10 @@
 
 SET( CORE_SRC_FILES
-	Factory.cc
-	IdentifierList.cc
-	Identifier.cc
-	MetaObjectList.cc
-	OrxonoxClass.cc
+  Factory.cc
+  IdentifierList.cc
+  Identifier.cc
+  MetaObjectList.cc
+  OrxonoxClass.cc
 )
 
 ADD_LIBRARY(core SHARED ${CORE_SRC_FILES})
-SET_TARGET_PROPERTIES(core PROPERTIES LINK_FLAGS "--no-undefined" )
Index: code/branches/FICN/src/orxonox/hud/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/hud/CMakeLists.txt	(revision 375)
+++ code/branches/FICN/src/orxonox/hud/CMakeLists.txt	(revision 376)
@@ -2,10 +2,7 @@
 
 SET( HUD_SRC_FILES
-	hud_overlay.cc
-	test_overlay.cc
+  hud_overlay.cc
+  test_overlay.cc
 )
 
-LINK_DIRECTORIES(.)
-
 ADD_LIBRARY(hud SHARED ${HUD_SRC_FILES})
-SET_TARGET_PROPERTIES(hud PROPERTIES LINK_FLAGS "--no-undefined" )
Index: code/branches/FICN/src/orxonox/objects/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/objects/CMakeLists.txt	(revision 375)
+++ code/branches/FICN/src/orxonox/objects/CMakeLists.txt	(revision 376)
@@ -2,10 +2,9 @@
 
 SET( OBJECTS_SRC_FILES
-	BaseObject.cc
-	test1.cc
-	test2.cc
-	test3.cc
+  BaseObject.cc
+  test1.cc
+  test2.cc
+  test3.cc
 )
 
 ADD_LIBRARY(objects SHARED ${OBJECTS_SRC_FILES})
-SET_TARGET_PROPERTIES(objects PROPERTIES LINK_FLAGS "--no-undefined" )
Index: code/branches/FICN/src/orxonox/weapon/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/orxonox/weapon/CMakeLists.txt	(revision 375)
+++ code/branches/FICN/src/orxonox/weapon/CMakeLists.txt	(revision 376)
@@ -2,12 +2,11 @@
 
 SET( WEAPON_SRC_FILES
-	ammunition_dump.cc
-	barrel_gun.cc
-	base_weapon.cc
-	bullet.cc
-	bullet_manager.cc
-	weapon_station.cc
+  ammunition_dump.cc
+  barrel_gun.cc
+  base_weapon.cc
+  bullet.cc
+  bullet_manager.cc
+  weapon_station.cc
 )
 
 ADD_LIBRARY(weapon SHARED ${WEAPON_SRC_FILES})
-SET_TARGET_PROPERTIES(weapon PROPERTIES LINK_FLAGS "--no-undefined" )